IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'CONTABILIZA_NF_SAIDA' AND
                 TYPE = 'P' 	         AND
	              U.UID = O.UID      AND
	              U.NAME = USER)
DROP PROCEDURE CONTABILIZA_NF_SAIDA
GO
                                                       
CREATE PROCEDURE CONTABILIZA_NF_SAIDA (
   @P_NRLISTA     VARCHAR(10))
AS
BEGIN
   DECLARE @V_VRCONTITEM      FLOAT;
   DECLARE @V_VRCONTITEMNF    FLOAT;
   DECLARE @V_COUNTITEMPROD   FLOAT;
   DECLARE @V_VRCONTITEMTOT   FLOAT;
   DECLARE @V_VRPARTRATE      FLOAT;
   DECLARE @V_VRRATENF        FLOAT;
   DECLARE @V_VRRATEIO        FLOAT;
   DECLARE @V_VRITEMENCA      FLOAT;
   DECLARE @V_VRIMPOSTONF     FLOAT;
   DECLARE @V_DBVRPARTIDAS    FLOAT;
   DECLARE @V_DBVRCONTITEM    FLOAT;
   DECLARE @V_VRPECREPREST    FLOAT; 
                                        
   DECLARE @V_COUNTRATEIO     INT;
   DECLARE @V_COUNTITEMNFORIG INT;
   DECLARE @V_INPARTIDAS      INT;
   DECLARE @V_RATEIO          INT;
   DECLARE @V_NRSEQEXIS       INT;
   DECLARE @V_CONTIMPO        INT;
                                        
   DECLARE @V_VRFATORMULT        DOUBLE PRECISION;
   DECLARE @V_VRIMPOSRETIDO      DOUBLE PRECISION;
   DECLARE @V_VRLANCCORPO        DOUBLE PRECISION;
   DECLARE @V_VRLANCCORPOAJUST   DOUBLE PRECISION;
   DECLARE @V_VRSUBSTRIB         DOUBLE PRECISION;
   DECLARE @V_VRPARTIDAS         DOUBLE PRECISION;    
   DECLARE @V_INRATEIO           INT;
                                        
   DECLARE @V_CDFILICCUST        VARCHAR(4);
   DECLARE @V_NRLANCCONT         VARCHAR(12);
   DECLARE @V_PRXNRLANCCONT      VARCHAR(20);
   DECLARE @V_CDCCTBLCORPO       VARCHAR(20);
   DECLARE @V_CDCCTBLPROD        VARCHAR(20);
   DECLARE @V_CDHISTPADR         VARCHAR(04);
   DECLARE @V_CDMODDOCFISC       VARCHAR(02);
   DECLARE @V_CDFILIORIG         VARCHAR(04);
   DECLARE @V_NRLANCORIG         VARCHAR(04);
   DECLARE @V_IDLANCCOME         VARCHAR(1);
   DECLARE @V_CDCONTCOME         VARCHAR(21);
   DECLARE @V_CDFILIALITEM       VARCHAR(4);
   DECLARE @V_NRLANCTONFITEM     VARCHAR(10); 
   DECLARE @V_CDCENTCUST         VARCHAR(4);
   DECLARE @V_FILIALVRNFORIG     VARCHAR(4);
   DECLARE @V_NRLANCTONF         VARCHAR(10);
   DECLARE @V_CDCTBLENTRPF       VARCHAR(20);
   DECLARE @V_CDCTBLSAIDPF       VARCHAR(20); 
   DECLARE @V_STCONTATIV         VARCHAR(20);
   DECLARE @V_STCONTAPASS        VARCHAR(20);
   DECLARE @V_STCONTADESP        VARCHAR(20); 
   DECLARE @V_CDIMPOSTRIB        VARCHAR(2);
   DECLARE @V_NRLANCTONFMOD      VARCHAR(10);
   DECLARE @V_CDPRODUTO          VARCHAR(10);
   DECLARE @V_STCONTCTBL         VARCHAR(20);
   DECLARE @V_STCONTCTBLP        VARCHAR(20);
   DECLARE @V_DSHISTPADR         VARCHAR(1000);
   DECLARE @V_CDLOTE             VARCHAR(20);
   DECLARE @V_NRLANCLOTE         VARCHAR(6);
   DECLARE @V_DESCITEMCTBLENTR   VARCHAR(20);
   DECLARE @V_DESCITEMCTBLSAID   VARCHAR(20);
   DECLARE @V_CDARVPROD          VARCHAR(10);
   DECLARE @V_STCONTPASS         VARCHAR(20);
   DECLARE @V_DSMODDOCFISC       VARCHAR(100);
   DECLARE @V_CDTPREGFISC        VARCHAR(20);
   DECLARE @V_CDFILIALMOD        VARCHAR(04);
   DECLARE @V_CDCTBLFORNCLI      VARCHAR(20);
   DECLARE @V_STCONTDIFE         VARCHAR(20);
   DECLARE @V_STCONTPROD         VARCHAR(20);
   DECLARE @V_CDIMPCARGATRIB     VARCHAR(20);
   DECLARE @V_CDCCTBLATIV        VARCHAR(20);
   DECLARE @V_CCTBLPASS          VARCHAR(20);
   DECLARE @V_CDCCTBLDESP        VARCHAR(20);
   DECLARE @V_CDTPCTRECEB        VARCHAR(04);
   DECLARE @V_CDCLASSFINA        VARCHAR(20);
   DECLARE @V_DTCONTABIL         DATETIME;

   /* VARIAVEIS DO CURSOR C_NF */
   DECLARE @C_NF_CDFILIAL      VARCHAR(4);
   DECLARE @C_NF_NRLANCTONF    VARCHAR(10);
   DECLARE @C_NF_CDEMPRESA     VARCHAR(2);
   DECLARE @C_NF_IDDOCFINANC   VARCHAR(1);
   DECLARE @C_NF_NRNOTAFISC    VARCHAR(20);
   DECLARE @C_NF_CDCLIENTE     VARCHAR(21);
   DECLARE @C_NF_CDFORNECED    VARCHAR(21);
   DECLARE @C_NF_NRLANCTBDOC   VARCHAR(12);
   DECLARE @C_NF_VRNOTAFISC    DOUBLE PRECISION;
   DECLARE @C_NF_CDFILIEMIT    VARCHAR(4);
   DECLARE @C_NF_CDTIPOOPER    VARCHAR(2);
   DECLARE @C_NF_IDCONTABOPER  VARCHAR(1);
   DECLARE @C_NF_IDOPERDEVONF  VARCHAR(1);
   DECLARE @C_NF_IDORIGDESTNF  VARCHAR(1);
   DECLARE @C_NF_VRPRODUTOS    DOUBLE PRECISION;
   DECLARE @C_NF_CDFILIRECE    VARCHAR(4);
   DECLARE @C_NF_DTENTRSAID    DATETIME;
   DECLARE @C_NF_CDINSCESTA    VARCHAR(16);
   DECLARE @C_NF_DTEMISSAO     CHAR(10);
   DECLARE @C_NF_IDPRIPUBCLIE  VARCHAR(1);
   DECLARE @C_NF_IDENTRSAIDOP  VARCHAR(1);
   DECLARE @C_NF_CDCENTCUST    VARCHAR(4);
   DECLARE @C_NF_CDSERIEENTR   VARCHAR(5);
   DECLARE @C_NF_CDSERIE       VARCHAR(5);
   DECLARE @C_NF_IDTPIJURNF    VARCHAR(1);
   DECLARE @C_NF_NRINSJURNF    VARCHAR(20);
   DECLARE @C_NF_IDDTCONTAB    VARCHAR(1);

   /* VARIAVEIS DO CURSOR C_IE */
   DECLARE @C_IE_VRITEMENCA       DOUBLE PRECISION;
   DECLARE @C_IE_CDCTBLENTREN     VARCHAR(20);
   DECLARE @C_IE_CDCTBLSAIDEN     VARCHAR(20);
   DECLARE @C_IE_IDENCARGO        VARCHAR(1);

   /* VARIAVEIS DO CURSOR C_IP*/
   DECLARE @C_IP_CDIMPOSTO         VARCHAR(2);
   DECLARE @C_IP_IDTRATIMPO        VARCHAR(1);
   DECLARE @C_IP_IDIMPORECUP       VARCHAR(1);
   DECLARE @C_IP_IDTRIMPOSTNF      VARCHAR(1);
   DECLARE @C_IP_IDACRPRODENTRNF   VARCHAR(1);
   DECLARE @C_IP_VRIMPOSTONF       DOUBLE PRECISION;
   DECLARE @C_IP_VRIMPCARGATRIBI   DOUBLE PRECISION;

   /* VARIAVEIS DO CURSOR C_ITEMPRODUTO */
   DECLARE @C_ITEMPRODUTO_NRSEQITPROD     VARCHAR(04);
   DECLARE @C_ITEMPRODUTO_CDPRODUTO       VARCHAR(10);
   DECLARE @C_ITEMPRODUTO_VRCONTITEM      DOUBLE PRECISION;
   DECLARE @C_ITEMPRODUTO_CDCTBLENTRPR    VARCHAR(20);
   DECLARE @C_ITEMPRODUTO_CDCTBLSAIDPR    VARCHAR(20);
   DECLARE @C_ITEMPRODUTO_VRDESCITEM      CHAR(10);

   /* VARIAVEIS DO CURSOR C_RATEIONF */
   DECLARE @C_RATEIONF_CDFILICCUST    VARCHAR(4);
   DECLARE @C_RATEIONF_CDCENTCUSNF    VARCHAR(4);
   DECLARE @C_RATEIONF_VRRATENF       DOUBLE PRECISION;

   /* VARIAVEIS DO CURSOR C_DESCITEM */
   DECLARE @C_DESCITEM_VRITEMENCA         DOUBLE PRECISION;
   DECLARE @C_DESCITEM_VRITEMENCAAJUST    DOUBLE PRECISION;
   DECLARE @C_DESCITEM_CDCTBLENTREN       VARCHAR(20);
   DECLARE @C_DESCITEM_CDCTBLSAIDEN       VARCHAR(20);

   /* VARIAVEIS DO CURSOR C_IMP */
   DECLARE @C_IMP_CDIMPOSTO               VARCHAR(2);
   DECLARE @C_IMP_IDTRATIMPO              VARCHAR(1);
   DECLARE @C_IMP_IDIMPORECUP             VARCHAR(1);
   DECLARE @C_IMP_IDTRIMPOSTNF            VARCHAR(1);
   DECLARE @C_IMP_IDACRPRODENTRNF         VARCHAR(1);
   DECLARE @C_IMP_VRIMPOSTONF             DOUBLE PRECISION;
   DECLARE @C_IMP_VRIMPCARGATRIBI         DOUBLE PRECISION;
   DECLARE @C_IMP_VRIMPOSTONFAJUST        DOUBLE PRECISION;
   DECLARE @C_IMP_VRIMPCARGATRIBIAJUST    DOUBLE PRECISION;

   /* VARIAVEIS DO CURSOR C_AJUSTE */
   DECLARE @C_AJUSTE_DSAJUSTEREC         VARCHAR(20);
   DECLARE @C_AJUSTE_VRAJUSTEREC         DOUBLE PRECISION;
   DECLARE @C_AJUSTE_IDAJUCTREC          VARCHAR(1);
   DECLARE @C_AJUSTE_CDHISTPADR          VARCHAR(4);
   DECLARE @C_AJUSTE_CDCONTCTBL          VARCHAR(20);
   DECLARE @C_AJUSTE_VRAJUSTERECAJUST    DOUBLE PRECISION;
                                                                                                  
                                                                                                       
   EXEC EXCLUI_LANCCONTABIL '01',P_NRLISTA; 

   DECLARE C_NF CURSOR FOR 
      SELECT
         NF.CDFILIAL, NF.NRLANCTONF, NF.CDEMPRESA,
         NF.IDDOCFINANC, NF.NRNOTAFISC, NF.CDCLIENTE,
         NF.CDFORNECED, NF.NRLANCTBDOC, NF.VRNOTAFISC,
         NF.CDFILIEMIT, NF.CDTIPOOPER, TP.IDCONTABOPER,
         TP.IDOPERDEVONF, ISNULL(NF.IDORIGDESTNF,'F') AS IDORIGDESTNF, NF.VRPRODUTOS,
         NF.CDFILIRECE, NF.DTENTRSAID, NF.CDINSCESTA,
         NF.DTEMISSAO, C.IDPRIPUBCLIE, NF.IDENTRSAIDOP,
         ISNULL(FI.CDCENTCUST, EP.CDCENTCUST) AS CDCENTCUST,
         NF.CDSERIEENTR, NF.CDSERIE, NF.IDTPIJURNF, NF.NRINSJURNF, TP.IDDTCONTAB
       FROM NOTAFISCAL NF, FILIAL FI, EMPRESA EP,
            TIPOOPERAC TP, CLIENTE C, LISTA LI
      WHERE NF.CDFILIAL     = SUBSTRING(LI.NRLISTA,1,4)
        AND NF.NRLANCTONF   = SUBSTRING(LI.NRLISTA,5,10)
        AND NF.CDEMPRESA    = EP.CDEMPRESA
        AND NF.IDENTRSAIDOP = TP.IDENTRSAIDOP
        AND NF.CDTIPOOPER   = TP.CDTIPOOPER
        AND ISNULL(TP.IDCONTABOPER,'S') = 'S'
        AND (CASE NF.IDENTRSAIDOP WHEN 'E' THEN NF.CDFILIRECE ELSE NF.CDFILIEMIT END) = FI.CDFILIAL
        AND NF.CDCLIENTE    *= C.CDCLIENTE 
        AND LI.NRLISTA = @P_NRLISTA
                                                                          
   OPEN C_NF;
   FETCH NEXT FROM C_NF INTO @C_NF_CDFILIAL,     @C_NF_NRLANCTONF,   @C_NF_CDEMPRESA,   @C_NF_IDDOCFINANC,
                             @C_NF_NRNOTAFISC,   @C_NF_CDCLIENTE,    @C_NF_CDFORNECED,  @C_NF_NRLANCTBDOC,
                             @C_NF_VRNOTAFISC,   @C_NF_CDFILIEMIT,   @C_NF_CDTIPOOPER,  @C_NF_IDCONTABOPER,
                             @C_NF_IDOPERDEVONF, @C_NF_IDORIGDESTNF, @C_NF_VRPRODUTOS,  @C_NF_CDFILIRECE,
                             @C_NF_DTENTRSAID,   @C_NF_CDINSCESTA,   @C_NF_DTEMISSAO,   @C_NF_IDPRIPUBCLIE,
                             @C_NF_IDENTRSAIDOP, @C_NF_CDCENTCUST,   @C_NF_CDSERIEENTR, @C_NF_CDSERIE,
                             @C_NF_IDTPIJURNF,   @C_NF_NRINSJURNF,   @C_NF_IDDTCONTAB;

   WHILE (@@FETCH_STATUS = 0) BEGIN
   /* TESTE */

     EXEC GERA_LOTECONTABIL @C_NF_CDEMPRESA, '01', '', @C_NF_CDFILIEMIT, @C_NF_DTENTRSAID, @C_NF_CDTIPOOPER, '', @V_CDLOTE, @V_NRLANCLOTE;

     IF @C_NF_IDCONTABOPER <> 'N' BEGIN
        IF @C_NF_IDDTCONTAB IS NULL BEGIN
           IF @C_NF_IDORIGDESTNF = 'L' BEGIN
              SET @V_DTCONTABIL = @C_NF_DTENTRSAID;
           END
           ELSE IF @C_NF_DTEMISSAO IS NOT NULL BEGIN
                   SET @V_DTCONTABIL = @C_NF_DTEMISSAO;
                END
                ELSE BEGIN
                   SET @V_DTCONTABIL = @C_NF_DTENTRSAID;
                END;  
        END      
        ELSE BEGIN
          IF @C_NF_IDDTCONTAB = 'M' BEGIN
             SET @V_DTCONTABIL = @C_NF_DTENTRSAID;
          END
          ELSE IF @C_NF_DTEMISSAO IS NOT NULL BEGIN
                  SET @V_DTCONTABIL = @C_NF_DTEMISSAO;
               END
               ELSE BEGIN
                 SET @V_DTCONTABIL = @C_NF_DTENTRSAID;
               END;
        END;
                                                              
        SELECT @V_CDCTBLFORNCLI = C.CDCTBLFORNCLI
          FROM CTBPRDTPOPER C,
               (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                  FROM CTBPRDTPOPER A, PRODUTO P, ITEMPRODUTO I, PRODUTO PR
                 WHERE IDENTRSAIDOP = 'E'
                   AND CDTIPOOPER   = @C_NF_CDTIPOOPER   
                   AND P.CDARVPROD  LIKE PR.CDARVPROD + '%'
                   AND P.CDPRODUTO  = I.CDPRODUTO 
                   AND I.CDFILIAL   = @C_NF_CDFILIAL
                   AND I.NRLANCTONF = @C_NF_NRLANCTONF 
                   AND A.CDCTBLFORNCLI IS NOT NULL 
                   AND A.CDPRODUTO  = PR.CDPRODUTO) PR,
               PRODUTO P
         WHERE IDENTRSAIDOP = 'E' 
           AND CDTIPOOPER   = @C_NF_CDTIPOOPER 
           AND C.CDPRODUTO  = P.CDPRODUTO  
           AND P.CDARVPROD  = PR.CDARVPROD;
            
      IF (@C_NF_IDORIGDESTNF IS NULL) OR (@C_NF_IDORIGDESTNF = 'C') BEGIN
         SET @V_IDLANCCOME = 'C';
         SET @V_CDCONTCOME = @C_NF_CDCLIENTE; 
      /* guilherme */
         
         EXEC CONTCTBL_CLIENTE @C_NF_CDEMPRESA, @C_NF_CDTIPOOPER, 'S', @C_NF_CDFILIEMIT, @C_NF_CDCLIENTE, @V_STCONTCTBL,
                               @V_STCONTCTBLP, @V_STCONTDIFE, @V_CDHISTPADR;
      END  
      ELSE IF @C_NF_IDORIGDESTNF = 'F' BEGIN
              SET @V_IDLANCCOME = 'F';
              SET @V_CDCONTCOME = @C_NF_CDFORNECED;
      /* GUILHERME */
                                                    
              EXEC CONTCTBL_FORNECEDOR @C_NF_CDEMPRESA, @C_NF_CDTIPOOPER, 'S', @C_NF_CDFILIEMIT, @C_NF_CDFORNECED, @V_STCONTCTBL, 
                                       @V_STCONTCTBLP, @V_STCONTDIFE, @V_CDHISTPADR;
           END
           ELSE IF @C_NF_IDORIGDESTNF = 'L' BEGIN
                   SET @V_IDLANCCOME = ' ';
                   SET @V_CDCONTCOME = '';
           /* GUILHERME */
                                                         
                   EXEC CONTCTBL_FILIAL @C_NF_CDEMPRESA, @C_NF_CDTIPOOPER, 'S', @C_NF_CDFILIEMIT, @V_STCONTCTBL, @V_STCONTCTBLP, 
                                        @V_STCONTDIFE, @V_CDHISTPADR;
                END;
      
      IF @V_CDCTBLFORNCLI IS NOT NULL BEGIN
         SET @V_STCONTCTBL = @V_CDCTBLFORNCLI;
      END;   
                                                                        
      /*LANCAMENTOS DE DEBITO*/
                                                                           
      SELECT @V_VRIMPOSRETIDO = ISNULL(ROUND(SUM(VRIMPOSTONF),2),0)
        FROM IMPOSTONF INF, IMPOSTO I
       WHERE CDFILIAL       = @C_NF_CDFILIAL 
         AND NRLANCTONF     = @C_NF_NRLANCTONF 
         AND INF.CDIMPOSTO  = I.CDIMPOSTO
         AND I.IDTRATIMPO   = 'R'
         AND I.IDTIPCONTAB  = 'D'
         AND (((IDIMPORECUP = 'S') AND ((CDCCTBLATIV IS NULL) OR (CDFISCALNF <> '1'))) OR (IDIMPORECUP <> 'S'));
        
      SET @V_VRLANCCORPO = - (@C_NF_VRNOTAFISC - @V_VRIMPOSRETIDO);
      
      /*MONTA HISTORICO PADRAO*/
      
      EXEC MONTA_HISTORICO @C_NF_CDFILIAL, @C_NF_NRLANCTONF, @V_CDHISTPADR, @C_NF_NRNOTAFISC, @C_NF_DTEMISSAO, '00', '', @V_DSHISTPADR;
      
      /*INSERE PARTIDA DE CREDITO*/
      SET @V_VRLANCCORPOAJUST = ROUND(@V_VRLANCCORPO,2);
      EXEC NOVA_PARTIDA @C_NF_CDEMPRESA,@V_CDLOTE,@V_DTCONTABIL,@V_NRLANCLOTE, @V_STCONTCTBL, @V_CDHISTPADR,
                        @V_DSHISTPADR, @V_VRLANCCORPOAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

      /*INSERE RATEIO*/              
      EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @C_NF_DTENTRSAID, @V_NRLANCLOTE, @C_NF_CDFILIEMIT,
                          @C_NF_CDCENTCUST, @V_VRLANCCORPO;
                     
      /* LANAMENTOS DE CREDITO */               
                                                       
      DECLARE C_IE CURSOR FOR (
         SELECT ISNULL(VRITEMENCA,0) AS VRITEMENCA, CDCTBLENTREN, CDCTBLSAIDEN, IDENCARGO
           FROM ITEMENCARGO IE, ENCARGO E
          WHERE IE.CDFILIAL   = @C_NF_CDFILIAL
            AND IE.NRLANCTONF = @C_NF_NRLANCTONF
            AND IE.CDENCARGO  = E.CDENCARGO
            AND IE.VRITEMENCA > 0
            AND E.IDENCARGO   IN ('A','D')
            AND ((CASE 'E' WHEN 'E' THEN CDCTBLENTREN ELSE CDCTBLSAIDEN END) IS  NOT NULL))

      OPEN C_IE;
      FETCH NEXT FROM C_IE INTO @C_IE_VRITEMENCA, @C_IE_CDCTBLENTREN, @C_IE_CDCTBLSAIDEN, @C_IE_IDENCARGO;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         IF @C_IE_IDENCARGO = 'A' BEGIN
            SET @V_VRLANCCORPO = @V_VRLANCCORPO + (@C_IE_VRITEMENCA);
         END
         ELSE BEGIN
            SET @V_VRLANCCORPO = @V_VRLANCCORPO - (@C_IE_VRITEMENCA);
         END;
         FETCH NEXT FROM C_IE INTO @C_IE_VRITEMENCA, @C_IE_CDCTBLENTREN, @C_IE_CDCTBLSAIDEN, @C_IE_IDENCARGO;
      END;

      DECLARE C_IP CURSOR FOR
         SELECT A.CDIMPOSTO, A.IDTRATIMPO, A.IDIMPORECUP, A.IDTRIMPOSTNF, A.IDACRPRODENTRNF,
                ISNULL(ROUND(SUM(A.VRIMPOSTONF),2),0) AS VRIMPOSTONF,
                MAX(CDCONTATIV) AS CDCONTATIV, MAX(CDCONTPASS)  AS CDCCONTPASS,
                MAX(CDCONTDESP)  AS CDCONTDESP
           FROM (SELECT INF.CDIMPOSTO, VRIMPOSTONF, VRIMPCARGATRIBI, ISNULL(IDACRPRODENTRNF, 'N') IDACRPRODENTRNF,
                        PF.IDCARACFIS, I.IDIMPORECUP, I.IDTRATIMPO, INF.CDFISCALNF, INF.IDTRIMPOSTNF,
                        TEKNISA.CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'A', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTATIV,
                        TEKNISA.CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'P', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTPASS,
                        TEKNISA.CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'D', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTDESP
                   FROM IMPOSTONF INF, IMPOSTO I, NOTAFISCAL NF, PARAMFILIAL PF
                  WHERE NF.CDFILIAL     = @C_NF_CDFILIAL
                    AND NF.NRLANCTONF   = @C_NF_NRLANCTONF
                    AND PF.CDFILIAL     =* NF.CDFILIRECE
                    AND INF.CDFILIAL    = @C_NF_CDFILIAL
                    AND INF.NRLANCTONF  = @C_NF_NRLANCTONF
                    AND INF.CDIMPOSTO   = I.CDIMPOSTO
                    AND INF.VRIMPOSTONF > 0
                    AND INF.IDIMPOSTONF IN ('1','4')
                    AND I.IDTIPCONTAB  = 'D') A
          WHERE ((((A.IDIMPORECUP  = 'S' AND A.CDFISCALNF = '1' AND ISNULL(A.IDCARACFIS,'C') = 'C') OR (A.IDCARACFIS = 'A')) AND
                (A.CDCONTATIV IS NOT NULL)) OR ((A.IDIMPORECUP <> 'S') AND (A.CDCONTPASS IS NOT NULL)))
          GROUP BY A.CDIMPOSTO, A.IDTRATIMPO,  A.IDIMPORECUP, A.IDACRPRODENTRNF, A.IDTRIMPOSTNF

      OPEN C_IP;
      FETCH NEXT FROM C_IP INTO @C_IP_CDIMPOSTO, @C_IP_IDTRATIMPO, @C_IP_IDIMPORECUP, @C_IP_IDTRIMPOSTNF,
                                @C_IP_IDACRPRODENTRNF, @C_IP_VRIMPOSTONF, @C_IP_VRIMPCARGATRIBI,
                                @V_CDCCTBLATIV, @V_CCTBLPASS, @V_CDCCTBLDESP;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         SELECT @V_CDIMPCARGATRIB = ISNULL(CDIMPCARGATRIB,'0'),
                @V_CDCCTBLATIV    = ISNULL(CDCCTBLATIV,'0'),
                @V_CCTBLPASS      = ISNULL(CDCCTBLPASS,'0'),
                @V_CDCCTBLDESP    = ISNULL(CDCCTBLDESP,'0')
           FROM IMPOSTO
          WHERE CDIMPOSTO = @C_IP_CDIMPOSTO;

         IF @C_IP_VRIMPOSTONF > 0 BEGIN
            IF @C_NF_IDOPERDEVONF <> 'S' BEGIN
               SELECT @V_CDIMPOSTRIB = MAX(CDIMPOSTO) /*AS CDIMPOSTRIB*/
                 FROM IMPOSTO
                WHERE CDIMPOSTRIB = @C_IP_CDIMPOSTO;

               IF @V_CDIMPOSTRIB IS NOT NULL BEGIN
                  IF @C_IP_IDTRATIMPO = 'R' BEGIN
                     SET @V_VRLANCCORPO = @V_VRLANCCORPO - ROUND(@C_IP_VRIMPOSTONF,2);
                  END
                  ELSE IF (@C_IP_IDTRATIMPO = 'V') AND (@C_NF_IDORIGDESTNF = 'L') BEGIN
                           SET @V_VRLANCCORPO = @V_VRLANCCORPO + ROUND(@C_IP_VRIMPOSTONF,2);
                       END;
               END
               ELSE BEGIN
                 SET @V_VRLANCCORPO = @V_VRLANCCORPO + ROUND(@C_IP_VRIMPOSTONF,2);
               END;
            END;
         END;
         FETCH NEXT FROM C_IP INTO @C_IP_CDIMPOSTO, @C_IP_IDTRATIMPO, @C_IP_IDIMPORECUP, @C_IP_IDTRIMPOSTNF,
                                   @C_IP_IDACRPRODENTRNF, @C_IP_VRIMPOSTONF, @C_IP_VRIMPCARGATRIBI,
                                   @V_CDCCTBLATIV, @V_CCTBLPASS, @V_CDCCTBLDESP;
      END;

      /* DESCITEM */
      SELECT @V_VRITEMENCA       = ISNULL(ROUND(SUM(VRDESCITEM),2),0) /*AS VRITEMENCA*/,
             @V_DESCITEMCTBLENTR = CDCTBLENTREN,
             @V_DESCITEMCTBLSAID = CDCTBLSAIDEN
        FROM ITEMPRODUTO I,
             (SELECT CDCONTDITEN AS CDCTBLENTREN,
                     CDCONTDITSA AS CDCTBLSAIDEN
                FROM PARAMCTBL
               WHERE (CASE 'S' WHEN 'E' THEN CDCONTDITEN ELSE CDCONTDITSA END) IS NOT NULL) E
       WHERE I.CDFILIAL   = @C_NF_CDFILIAL
         AND I.NRLANCTONF = @C_NF_NRLANCTONF
       GROUP BY CDCTBLENTREN, CDCTBLSAIDEN
      HAVING ROUND(SUM(VRDESCITEM),2) > 0;

      SET @V_DBVRPARTIDAS = 0;

      SELECT @V_NRSEQEXIS = MAX(IT.NRSEQITPROD)
        FROM ITEMPRODUTO IT, PRODUTO P, PRODUTO PR
       WHERE CDFILIAL     = @C_NF_CDFILIAL
         AND NRLANCTONF   = @C_NF_NRLANCTONF
         AND VRCONTITEM   > 0
         AND (P.CDARVPROD = (SELECT MAX(CDARVPROD)
                               FROM PRODUTO C
                              WHERE (CHARINDEX(RTRIM(C.CDARVPROD), PR.CDARVPROD) = 1)
                                AND NOT ((CASE @C_NF_IDENTRSAIDOP WHEN 'E' THEN CDCTBLENTRPR ELSE CDCTBLSAIDPR END) IS NULL)) OR
                                         IT.CDPRODUTO = P.CDPRODUTO)
         AND IT.CDPRODUTO = PR.CDPRODUTO;

      IF @V_NRSEQEXIS IS NOT NULL BEGIN

         DECLARE C_ITEMPRODUTO CURSOR FOR (
              SELECT IT.NRSEQITPROD, IT.CDPRODUTO,
                     ROUND(VRCONTITEM,2) VRCONTITEM,
                     MAX(P.CDCTBLENTRPR) AS CDCTBLENTRPR,
                     MAX(P.CDCTBLSAIDPR) AS CDCTBLSAIDPR,
                     ROUND(VRDESCITEM,2) VRDESCITEM
                FROM ITEMPRODUTO IT, PRODUTO P, PRODUTO PR
               WHERE CDFILIAL = @C_NF_CDFILIAL
                 AND NRLANCTONF = @C_NF_NRLANCTONF
                 AND VRCONTITEM > 0
                 AND (P.CDARVPROD = (SELECT MAX(CDARVPROD)
                                       FROM  PRODUTO C
                                      WHERE (CHARINDEX(RTRIM(C.CDARVPROD), PR.CDARVPROD) = 1)
                                        AND  NOT ((CASE 'S' WHEN 'E' THEN CDCTBLENTRPR ELSE CDCTBLSAIDPR END) IS NULL)) OR IT.CDPRODUTO = P.CDPRODUTO) AND
                     IT.CDPRODUTO = PR.CDPRODUTO
               GROUP BY IT.NRSEQITPROD, IT.CDPRODUTO, VRCONTITEM, VRDESCITEM)

         OPEN C_ITEMPRODUTO;
         FETCH NEXT FROM C_ITEMPRODUTO INTO @C_ITEMPRODUTO_NRSEQITPROD, @C_ITEMPRODUTO_CDPRODUTO, @C_ITEMPRODUTO_VRCONTITEM,
                                            @C_ITEMPRODUTO_CDCTBLENTRPR, @C_ITEMPRODUTO_CDCTBLSAIDPR, @C_ITEMPRODUTO_VRDESCITEM;

         WHILE (@@FETCH_STATUS = 0) BEGIN

               SET @V_INPARTIDAS = 1;

               IF (@C_NF_IDPRIPUBCLIE = 'B') AND (@V_STCONTDIFE IS NOT NULL) BEGIN
                   SET @V_STCONTPROD = @V_STCONTDIFE;
               END
               ELSE BEGIN
                  /* PRODUTO */
                   SELECT @V_CDARVPROD  = P.CDARVPROD,
                          @V_CDPRODUTO  = P.CDPRODUTO,
                          @V_CDCENTCUST = ISNULL(ISNULL(ISNULL(PR.CDCCUSTENTRF,P.CDCCUSTENTR),F.CDCENTCUST),E.CDCENTCUST) /*AS CDCENTCUST*/
                     FROM FILIAL F, NOTAFISCAL N, EMPRESA E,
                          PRODUTO P LEFT JOIN PRODFILI PR ON (PR.CDPRODUTO = P.CDPRODUTO)  AND
                                                             (PR.CDFILIAL  = @C_NF_CDFILIEMIT)
                    WHERE (P.CDPRODUTO     = @C_ITEMPRODUTO_CDPRODUTO)
                      AND (F.CDFILIAL      = @C_NF_CDFILIEMIT )
                      AND (N.CDFILIAL      = @C_NF_CDFILIAL)
                      AND (N.NRLANCTONF    = @C_NF_NRLANCTONF)
                      AND (N.CDEMPRESA     = @C_NF_CDEMPRESA)
                      AND (N.CDEMPRESA     = E.CDEMPRESA);

                  /*ContProdTp*/

                   SELECT @V_CDCCTBLPROD = C.CDCTBLPRODTO
                     FROM CTBPRDTPOPER C,
                          (SELECT MAX(P.CDARVPROD) AS CDARVPROD
                             FROM CTBPRDTPOPER A, PRODUTO P
                            WHERE IDENTRSAIDOP = 'E'
                              AND CDTIPOOPER   = @C_NF_CDTIPOOPER
                              AND P.CDPRODUTO  = A.CDPRODUTO
                              AND (CHARINDEX(RTRIM(P.CDARVPROD), @V_CDARVPROD) = 1)
                              AND A.CDCTBLPRODTO IS NOT NULL) PR,
                          PRODUTO P
                    WHERE IDENTRSAIDOP = 'E'
                      AND CDTIPOOPER   = @C_NF_CDTIPOOPER
                      AND C.CDPRODUTO  = P.CDPRODUTO
                      AND P.CDARVPROD = PR.CDARVPROD;

                   SET @V_STCONTPROD = @V_CDCCTBLPROD;
               
                  IF @V_STCONTPROD IS NOT NULL BEGIN
                     SET @V_STCONTPROD = @V_STCONTCTBLP;
                  END;   
               END;
                                       
               IF @V_STCONTPROD IS NULL BEGIN
                  SELECT @V_CDCTBLENTRPF = MAX(CDCTBLENTRPF) /*AS CDCTBLENTRPF*/,
                         @V_CDCTBLSAIDPF = MAX(CDCTBLSAIDPF) /*AS CDCTBLSAIDPF*/
                    FROM PRODFILI PF, PRODUTO P
                   WHERE CDFILIAL      = @C_NF_CDFILIEMIT   
                     AND PF.CDPRODUTO  = @V_CDPRODUTO
                     AND (P.CDPRODUTO IN (SELECT MAX(CDPRODUTO)
                                            FROM  PRODUTO C
                                           WHERE (CHARINDEX(RTRIM(C.CDPRODUTO), PF.CDPRODUTO) = 1) AND
                                             NOT ((CASE 'S' WHEN 'E' THEN CDCTBLENTRPF ELSE CDCTBLSAIDPF END) IS NULL))
                      OR PF.CDPRODUTO = P.CDPRODUTO);
               END;

               SET @V_STCONTPROD = @V_CDCTBLSAIDPF;

               IF @V_STCONTPROD IS NULL BEGIN
                  SET @V_STCONTPROD = @C_ITEMPRODUTO_CDCTBLSAIDPR;
               END;

               IF @C_ITEMPRODUTO_VRCONTITEM > 0 BEGIN
                  SET @V_DBVRCONTITEM = @C_ITEMPRODUTO_VRCONTITEM;
                  SET @V_DBVRPARTIDAS = @V_DBVRPARTIDAS + @C_ITEMPRODUTO_VRCONTITEM;

                  SELECT @V_COUNTITEMNFORIG = COUNT(*)
                    FROM ITEMPRODUTO I, PRODUTO P, PRODUTO PR, ITEMNOTAFISC IT, NOTAFISCAL N
                   WHERE IT.CDFILIAL     = I.CDFILIAL
                     AND IT.NRLANCTONF   = I.NRLANCTONF
                     AND N.CDFILIAL      = I.CDFILIAL
                     AND N.NRLANCTONF    = I.NRLANCTONF
                     AND N.IDENTRSAIDOP  = 'S'
                     AND IT.CDFILIALIT   = @C_NF_CDFILIAL
                     AND IT.NRLANCTONFIT = @C_NF_NRLANCTONF
                     AND P.CDCTBLENTRPR  IS NOT NULL
                     AND VRCONTITEM      > 0
                     AND (P.CDARVPROD = (SELECT MAX(CDARVPROD)
                                           FROM PRODUTO C
                                          WHERE (CHARINDEX(RTRIM(C.CDARVPROD), PR.CDARVPROD) = 1)
                                            AND NOT (CDCTBLENTRPR IS NULL)) OR (I.CDPRODUTO = P.CDPRODUTO))
                     AND I.CDPRODUTO = PR.CDPRODUTO
                   GROUP BY I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, I.CDPRODUTO, P.CDCTBLENTRPR;

                  IF @V_INPARTIDAS = @V_COUNTITEMNFORIG BEGIN
                     IF (ABS(ROUND(ABS(@V_DBVRPARTIDAS),2) - ROUND(ABS(@V_VRLANCCORPO),2)) <= 0.1) AND
                        (ROUND(ABS(@V_DBVRPARTIDAS),2) <> ROUND(ABS(@V_VRLANCCORPO),2)) BEGIN
                           SET @V_DBVRCONTITEM = ABS(@V_DBVRCONTITEM - (@V_DBVRPARTIDAS + @V_VRLANCCORPO));
                     END;
                  END;

                  IF ABS(@V_DBVRCONTITEM) > 0 BEGIN
                     EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTPROD, @V_CDHISTPADR,
                                       @V_DSHISTPADR, @V_DBVRCONTITEM, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

                     SELECT @V_CDFILICCUST = CDFILICCUST
                       FROM RATEIONF
                      WHERE CDFILIAL    = @C_NF_CDFILIAL
                        AND NRLANCTONF  = @C_NF_NRLANCTONF
                        AND NRSEQITPROD = @C_ITEMPRODUTO_NRSEQITPROD;
                     
                     SET @V_VRPARTRATE = 0;
                                 
                     IF @V_CDFILICCUST IS NOT NULL BEGIN
                        SET @V_RATEIO = 1;
                                  
                        DECLARE C_RATEIONF CURSOR FOR ( 
                                SELECT CDFILICCUST, CDCENTCUSNF,
                                       ISNULL(ROUND(VRRATENF,2),0) AS VRRATENF
                                  FROM RATEIONF
                                 WHERE CDFILIAL    = @C_NF_CDFILIAL   
                                   AND NRLANCTONF  = @C_NF_NRLANCTONF  
                                   AND NRSEQITPROD = @C_ITEMPRODUTO_NRSEQITPROD) 
                                                                     
                        OPEN C_RATEIONF;
                        FETCH NEXT FROM C_RATEIONF INTO @C_RATEIONF_CDFILICCUST, @C_RATEIONF_CDCENTCUSNF, @C_RATEIONF_VRRATENF;

                        WHILE (@@FETCH_STATUS = 0) BEGIN

                                SET @V_VRRATEIO = @C_RATEIONF_VRRATENF;
                                SET @V_VRPARTRATE = @V_VRPARTRATE + (@C_RATEIONF_VRRATENF);

                                SELECT @V_COUNTRATEIO = COUNT(*)
                                  FROM RATEIONF
                                 WHERE CDFILIAL    = @C_NF_CDFILIAL
                                   AND NRLANCTONF  = @C_NF_NRLANCTONF
                                   AND NRSEQITPROD = @C_ITEMPRODUTO_NRSEQITPROD;

                                 IF @V_RATEIO = @V_COUNTRATEIO BEGIN
                                    IF (ABS(ROUND(ABS(@V_VRPARTRATE),2) - ROUND(ABS(@V_DBVRCONTITEM),2)) <= 0.1) AND
                                       (ROUND(ABS(@V_VRPARTRATE),2) <> ROUND(ABS(@V_DBVRCONTITEM),2)) BEGIN
                                       SET @V_VRRATEIO = @V_VRRATEIO + (@V_VRPARTRATE - @V_DBVRCONTITEM);
                                    END;
                                 END;

                                 EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA,@V_CDLOTE,@V_DTCONTABIL,@V_NRLANCLOTE, @C_RATEIONF_CDFILICCUST,
                                                     @C_RATEIONF_CDCENTCUSNF, @V_VRRATEIO;

                                 SET @V_RATEIO = @V_RATEIO + 1;
                           FETCH NEXT FROM C_RATEIONF INTO @C_RATEIONF_CDFILICCUST, @C_RATEIONF_CDCENTCUSNF, @C_RATEIONF_VRRATENF;
                        END;
                     END
                     ELSE BEGIN
                        EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT,
                                            @V_CDCENTCUST, @V_DBVRCONTITEM;
                     END;
                  END;
               END;

               IF (@C_ITEMPRODUTO_VRDESCITEM > 0) AND (@V_DESCITEMCTBLSAID IS NOT NULL) BEGIN

                   EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTPROD, @V_CDHISTPADR, 
                                     @V_DSHISTPADR, @C_ITEMPRODUTO_VRDESCITEM, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';
                                                                                           
                   EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT, @V_CDCENTCUST,
                                       @C_ITEMPRODUTO_VRDESCITEM;             

                   SET @V_INPARTIDAS = @V_INPARTIDAS + 1;

                   SET @V_STCONTPROD = '';
               END;
            FETCH NEXT FROM C_ITEMPRODUTO INTO @C_ITEMPRODUTO_NRSEQITPROD, @C_ITEMPRODUTO_CDPRODUTO, @C_ITEMPRODUTO_VRCONTITEM,
                                               @C_ITEMPRODUTO_CDCTBLENTRPR, @C_ITEMPRODUTO_CDCTBLSAIDPR, @C_ITEMPRODUTO_VRDESCITEM;
         END;
      END
      ELSE BEGIN
         IF ABS(@V_VRLANCCORPO) > 0 BEGIN
            SET @V_STCONTPROD = @V_STCONTCTBLP;
            EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTPROD, @V_CDHISTPADR, @V_DSHISTPADR,
                              @V_VRLANCCORPO, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

            EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT, @V_CDCENTCUST,
                                @C_NF_CDCENTCUST;
         END;
      END;

      DECLARE C_DESCITEM CURSOR FOR (
         SELECT ISNULL(ROUND(SUM(VRDESCITEM),2),0) AS VRITEMENCA, CDCTBLENTREN, CDCTBLSAIDEN
           FROM ITEMPRODUTO I,
                (SELECT CDCONTDITEN AS CDCTBLENTREN,
                        CDCONTDITSA AS CDCTBLSAIDEN
                   FROM PARAMCTBL
                  WHERE (CASE 'S' WHEN 'E' THEN CDCONTDITEN ELSE CDCONTDITSA END) IS NOT NULL) E
          WHERE I.CDFILIAL   = @C_NF_CDFILIAL
            AND I.NRLANCTONF = @C_NF_NRLANCTONF
          GROUP BY CDCTBLENTREN, CDCTBLSAIDEN
         HAVING ROUND(SUM(VRDESCITEM),2) > 0)

      OPEN C_DESCITEM;
      FETCH NEXT FROM C_DESCITEM INTO @C_DESCITEM_VRITEMENCA, @C_DESCITEM_CDCTBLENTREN, @C_DESCITEM_CDCTBLSAIDEN;

      WHILE (@@FETCH_STATUS = 0) BEGIN
            SET @C_DESCITEM_VRITEMENCAAJUST = - @C_DESCITEM_VRITEMENCA;
            EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_DESCITEM_CDCTBLSAIDEN, @V_CDHISTPADR,
                              @V_DSHISTPADR, @C_DESCITEM_VRITEMENCAAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

            EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT,
                                @C_NF_CDCENTCUST, @C_DESCITEM_VRITEMENCAAJUST;
         FETCH NEXT FROM C_DESCITEM INTO @C_DESCITEM_VRITEMENCA, @C_DESCITEM_CDCTBLENTREN, @C_DESCITEM_CDCTBLSAIDEN;
      END;

      DECLARE C_IMP CURSOR FOR
         SELECT A.CDIMPOSTO, A.IDTRATIMPO, A.IDIMPORECUP, A.IDTRIMPOSTNF, A.IDACRPRODENTRNF,
                ISNULL(ROUND(SUM(A.VRIMPOSTONF),2),0) AS VRIMPOSTONF,
                ISNULL(ROUND(SUM(VRIMPCARGATRIBI),2),0) AS VRIMPCARGATRIBI,
                MAX(CDCONTATIV) AS CDCONTATIV, MAX(CDCONTPASS)  AS CDCCONTPASS,
                MAX(CDCONTDESP)  AS CDCONTDESP
           FROM (SELECT INF.CDIMPOSTO, VRIMPOSTONF, VRIMPCARGATRIBI, ISNULL(IDACRPRODENTRNF, 'N') IDACRPRODENTRNF,
                        PF.IDCARACFIS, I.IDIMPORECUP, I.IDTRATIMPO, INF.CDFISCALNF, INF.IDTRIMPOSTNF,
                        TEKNISA.CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'A', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTATIV,
                        TEKNISA.CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'P', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTPASS,
                        TEKNISA.CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'D', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) AS CDCONTDESP
                   FROM IMPOSTONF INF, IMPOSTO I, NOTAFISCAL NF, PARAMFILIAL PF
                  WHERE NF.CDFILIAL     = @C_NF_CDFILIAL
                    AND NF.NRLANCTONF   = @C_NF_NRLANCTONF
                    AND PF.CDFILIAL     =* NF.CDFILIRECE
                    AND INF.CDFILIAL    = @C_NF_CDFILIAL
                    AND INF.NRLANCTONF  = @C_NF_NRLANCTONF
                    AND INF.CDIMPOSTO   = I.CDIMPOSTO
                    AND INF.VRIMPOSTONF > 0
                    AND INF.IDIMPOSTONF IN ('1','4')
                    AND I.IDTIPCONTAB  = 'D') A
          WHERE ((((A.IDIMPORECUP  = 'S' AND A.CDFISCALNF = '1' AND ISNULL(A.IDCARACFIS,'C') = 'C') OR (A.IDCARACFIS = 'A')) AND
                (A.CDCONTATIV IS NOT NULL)) OR ((A.IDIMPORECUP <> 'S') AND (A.CDCONTPASS IS NOT NULL)))
          GROUP BY A.CDIMPOSTO, A.IDTRATIMPO,  A.IDIMPORECUP, A.IDACRPRODENTRNF, A.IDTRIMPOSTNF

      OPEN C_IMP;
      FETCH NEXT FROM C_IMP INTO @C_IMP_CDIMPOSTO, @C_IMP_IDTRATIMPO, @C_IMP_IDIMPORECUP, @C_IMP_IDTRIMPOSTNF,
                                 @C_IMP_IDACRPRODENTRNF, @C_IMP_VRIMPOSTONF, @C_IMP_VRIMPCARGATRIBI,
                                 @V_CDCCTBLATIV, @V_CCTBLPASS, @V_CDCCTBLDESP;

      WHILE (@@FETCH_STATUS = 0) BEGIN

           IF @C_IMP_VRIMPOSTONF > 0 BEGIN
              IF (@C_NF_IDOPERDEVONF <> 'S') BEGIN
                 SELECT @V_CDIMPOSTRIB = MAX(CDIMPOSTO)
                   FROM IMPOSTO
                   WHERE CDIMPOSTRIB = @C_IMP_CDIMPOSTO;

                 IF (@V_CDIMPOSTRIB IS NOT NULL) BEGIN
                     SET @C_IMP_VRIMPOSTONFAJUST = ROUND(@C_IMP_VRIMPOSTONF,2);
                     EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTAPASS, @V_CDHISTPADR,
                                       @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

                     EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA,@V_CDLOTE,@V_DTCONTABIL,@V_NRLANCLOTE, @C_NF_CDFILIEMIT,
                                         @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;
                     SET @C_IMP_VRIMPOSTONFAJUST = - ROUND(@C_IMP_VRIMPOSTONF,2);
                     EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTADESP, @V_CDHISTPADR, @V_DSHISTPADR,
                                       @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

                     EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT, @C_NF_CDCENTCUST,
                                         @C_IMP_VRIMPOSTONFAJUST;
                 END
                 ELSE BEGIN
                    IF @C_IMP_IDTRIMPOSTNF IS NOT NULL BEGIN
                       IF @C_IMP_IDTRIMPOSTNF = 'O' BEGIN
                          SET @C_IMP_VRIMPOSTONFAJUST = ROUND(@C_IMP_VRIMPOSTONF,2);
                          EXEC NOVA_PARTIDA @C_NF_CDEMPRESA,@V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTAPASS, @V_CDHISTPADR,
                                            @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

                          EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT, 
                                              @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;
                       END
                       ELSE BEGIN                            
                          SET @C_IMP_VRIMPOSTONFAJUST = ROUND(@C_IMP_VRIMPOSTONF,2);
                          EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTAPASS, @V_CDHISTPADR,
                                            @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';
                                                                    
                          EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT, 
                                              @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;
                                                                    
                          SET @C_IMP_VRIMPOSTONFAJUST =  - (@C_IMP_VRIMPOSTONFAJUST);                     
                          EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTADESP, @V_CDHISTPADR,
                                            @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';
                                                                                
                          EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT,
                                              @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;
                         END;
                    END
                    ELSE BEGIN
                       IF (@C_IMP_IDTRATIMPO = 'R') BEGIN
                          SET @C_IMP_VRIMPOSTONFAJUST = - ROUND(@C_IMP_VRIMPOSTONF,2);
                          EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTATIV, @V_CDHISTPADR, 
                                            @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';
                                                                             
                          EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT,
                                              @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;
                       END                                                      
                       ELSE IF (@C_IMP_IDTRATIMPO = 'A') BEGIN
                                SET @C_IMP_VRIMPOSTONFAJUST = ROUND(@C_IMP_VRIMPOSTONF,2);
                                EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTAPASS, 
                                                  @V_CDHISTPADR, @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME, @V_CDCONTCOME, 
                                                  '01', 'S';
                                                                                                
                                EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT, 
                                                    @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;
                            END
                            ELSE IF (@C_IMP_IDTRATIMPO = 'D') BEGIN
                                    SET @C_IMP_VRIMPOSTONFAJUST = - ROUND(@C_IMP_VRIMPOSTONF,2);
                                    EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTATIV,
                                                      @V_CDHISTPADR, @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME,
                                                      @V_CDCONTCOME, '01', 'S';

                                     EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE,
                                                         @C_NF_CDFILIEMIT, @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;
                                 END
                                 ELSE IF (@C_IMP_IDTRATIMPO = 'L') BEGIN
                                         SET @C_IMP_VRIMPOSTONFAJUST = ROUND(@C_IMP_VRIMPOSTONF,2);
                                         EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTAPASS,
                                                           @V_CDHISTPADR, @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME,
                                                           @V_CDCONTCOME, '01', 'S';

                                         EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT,
                                                             @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;
                                      END
                                      ELSE IF @C_IMP_VRIMPCARGATRIBI > 0 BEGIN
                                              SET @C_IMP_VRIMPCARGATRIBIAJUST =  ROUND(@C_IMP_VRIMPCARGATRIBI,2);
                                              EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_CCTBLPASS,
                                                                @V_CDHISTPADR, @V_DSHISTPADR, @C_IMP_VRIMPCARGATRIBIAJUST, @V_IDLANCCOME,
                                                                @V_CDCONTCOME, '01', 'S';

                                              EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE,
                                                                  @C_NF_CDFILIEMIT, @C_NF_CDCENTCUST, @C_IMP_VRIMPCARGATRIBIAJUST;

                                              SET @C_IMP_VRIMPCARGATRIBIAJUST =  - ROUND(@C_IMP_VRIMPCARGATRIBI,2);
                                              EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE,
                                                                @V_CDCCTBLDESP, @V_CDHISTPADR, @V_DSHISTPADR, @C_IMP_VRIMPCARGATRIBIAJUST,
                                                                @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

                                              EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE,
                                                                  @C_NF_CDFILIEMIT, @C_NF_CDCENTCUST, @C_IMP_VRIMPCARGATRIBIAJUST;
                                           END
                                           ELSE IF @C_IMP_CDIMPOSTO <> @V_CDIMPCARGATRIB BEGIN
                                                   SET @C_IMP_VRIMPOSTONFAJUST = ROUND(@C_IMP_VRIMPOSTONF,2);
                                                   EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE,
                                                                     @V_STCONTAPASS, @V_CDHISTPADR, @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST,
                                                                     @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

                                                   EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE,
                                                                       @C_NF_CDFILIEMIT, @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;

                                                   SET @C_IMP_VRIMPOSTONFAJUST = - ROUND(@C_IMP_VRIMPOSTONF,2);
                                                   EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE,
                                                                     @V_STCONTADESP, @V_CDHISTPADR, @V_DSHISTPADR,@C_IMP_VRIMPOSTONFAJUST,
                                                                     @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

                                                   EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE,
                                                                       @C_NF_CDFILIEMIT, @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;
                                                END;
                                 END;
                    END;
                END
                ELSE BEGIN
                     SELECT @V_CDIMPOSTRIB = MAX(CDIMPOSTO)
                       FROM IMPOSTO
                      WHERE CDIMPOSTRIB = @C_IMP_CDIMPOSTO;

                     SELECT @V_CDMODDOCFISC  = A.CDMODDOCFISC,
                            @V_DSMODDOCFISC  =  A.DSMODDOCFISC,
                            @V_CDTPREGFISC   = A.CDTPREGFISC,
                            @V_NRLANCTONFMOD = N.NRLANCTONF,
                            @V_CDFILIALMOD   = N.CDFILIAL
                       FROM NOTAFISCAL N, MODDOCFISC A
                      WHERE (N.CDMODDOCFISC = A.CDMODDOCFISC)
                        AND (A.CDTPREGFISC  = '70')
                        AND (N.CDFILIAL     = @C_NF_CDFILIAL)
                        AND (N.NRLANCTONF   = @C_NF_NRLANCTONF)
                      ORDER BY A.CDMODDOCFISC;

                    IF (@V_CDIMPOSTRIB IS NOT NULL) AND (@V_CDMODDOCFISC IS NOT NULL) BEGIN
                       SET @C_IMP_VRIMPOSTONFAJUST = ROUND(@C_IMP_VRIMPOSTONF,2);
                       EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_CDCCTBLATIV, @V_CDHISTPADR,
                                         @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';
                                                                                  
                       EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT,
                                           @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;                                                  
                                                                                                                                      
                       SET @C_IMP_VRIMPOSTONFAJUST = - ROUND(@C_IMP_VRIMPOSTONF,2); 
                       EXEC NOVA_PARTIDA @C_NF_CDEMPRESA,@V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_CCTBLPASS, @V_CDHISTPADR,
                                         @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';
                                                                                  
                       EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT,
                                           @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;
                                                                                             
                       SELECT @V_VRPECREPREST = ISNULL(VRPECREPREST,0)
                         FROM FILIAL
                        WHERE CDFILIAL = @C_NF_CDFILIEMIT;

                       IF @V_VRPECREPREST > 0 BEGIN
                          SET @C_IMP_VRIMPOSTONFAJUST = - (ROUND(@C_IMP_VRIMPOSTONF,2) * @V_VRPECREPREST/100); 
                          EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_CDCCTBLATIV, @V_CDHISTPADR, 
                                            @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';
                                                                      
                          SET @C_IMP_VRIMPOSTONFAJUST = ROUND(@C_IMP_VRIMPOSTONF,2);
                          EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT,
                               @C_NF_CDCENTCUST,  @C_IMP_VRIMPOSTONFAJUST;
                                                                                                                
                          SET @C_IMP_VRIMPOSTONFAJUST = (ROUND(@C_IMP_VRIMPOSTONF,2) * @V_VRPECREPREST/100);
                          EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_CCTBLPASS, @V_CDHISTPADR,
                                            @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';
                                                                                   
                          SET @C_IMP_VRIMPOSTONFAJUST = - ROUND(@C_IMP_VRIMPOSTONF,2);
                          EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT,
                                              @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;
                       END;
                    END
                    ELSE IF (@C_IMP_IDTRATIMPO = 'A') AND (@C_IMP_IDACRPRODENTRNF = 'S') BEGIN
                             SET @C_IMP_VRIMPOSTONFAJUST = - ROUND(@C_IMP_VRIMPOSTONF,2);
                             EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTATIV, @V_CDHISTPADR,
                                               @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';
                                                                                  
                             EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT,
                                                 @C_NF_CDCENTCUST,  @C_IMP_VRIMPOSTONFAJUST;
                         END
                         ELSE BEGIN
                             SET @C_IMP_VRIMPOSTONFAJUST = ROUND(@C_IMP_VRIMPOSTONF,2);
                             EXEC NOVA_PARTIDA @C_NF_CDEMPRESA,@V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTATIV, @V_CDHISTPADR,
                                               @V_DSHISTPADR, @C_IMP_VRIMPOSTONFAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';
                                                                                  
                             EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT, 
                                                 @C_NF_CDCENTCUST, @C_IMP_VRIMPOSTONFAJUST;
                         END;  
                END;           
           END;
         FETCH NEXT FROM C_IMP INTO @C_IMP_CDIMPOSTO, @C_IMP_IDTRATIMPO, @C_IMP_IDIMPORECUP, @C_IMP_IDTRIMPOSTNF,
                                    @C_IMP_IDACRPRODENTRNF, @C_IMP_VRIMPOSTONF, @C_IMP_VRIMPCARGATRIBI,
                                    @V_CDCCTBLATIV, @V_CCTBLPASS, @V_CDCCTBLDESP;
      END;

      SELECT @V_CDTPCTRECEB = CDTPCTRECEB,
             @V_CDCLASSFINA = CDCLASSFINA
        FROM CONTARECEBER
       WHERE CDFILIAL     = @C_NF_CDFILIAL
         AND NRLANCTONF   = @C_NF_NRLANCTONF
         AND (NRSEQVENREC = '' OR 'T' = 'T')
       ORDER BY CDFILIAL, NRLANCTONF, QTDIASVENREC;
     
       DECLARE C_AJUSTE CURSOR FOR (
         SELECT AJ.DSAJUSTEREC,
                SUM(AJ.VRAJUSTEREC) AS VRAJUSTEREC, TI.IDAJUCTREC,
                TI.CDHISTPADR, TI.CDCONTCTBL
           FROM AJCTRECEBER AJ, TIPOAJRECEBER TI
          WHERE AJ.CDFILIAL = @C_NF_CDFILIAL      
            AND AJ.NRLANCTONF = @C_NF_NRLANCTONF
            AND AJ.CDAJUCTREC = TI.CDAJUCTREC
          GROUP BY AJ.DSAJUSTEREC, TI.IDAJUCTREC,
                   TI.CDHISTPADR, TI.CDCONTCTBL) 
                                                       
      OPEN C_AJUSTE;
      FETCH NEXT FROM C_AJUSTE INTO @C_AJUSTE_DSAJUSTEREC, @C_AJUSTE_VRAJUSTEREC, @C_AJUSTE_IDAJUCTREC,
                                 @C_AJUSTE_CDHISTPADR, @C_AJUSTE_CDCONTCTBL;

      WHILE (@@FETCH_STATUS = 0) BEGIN

        /* MUDAR MONTA HISTORICO*/
        EXEC MONTA_HISTORICO @C_NF_CDFILIAL, @C_NF_NRLANCTONF, @V_CDHISTPADR, @C_NF_NRNOTAFISC, @C_NF_DTEMISSAO, '00', '', @V_DSHISTPADR;

        IF (@C_AJUSTE_IDAJUCTREC = 'D') BEGIN
            SET @C_AJUSTE_VRAJUSTERECAJUST = - @C_AJUSTE_VRAJUSTEREC;
            EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTCTBL, @C_AJUSTE_CDHISTPADR,
                              @V_DSHISTPADR, @C_AJUSTE_VRAJUSTERECAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

            EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT, @C_NF_CDCENTCUST,
                                @C_AJUSTE_VRAJUSTERECAJUST;

            EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_AJUSTE_CDCONTCTBL, @C_AJUSTE_CDHISTPADR,
                              @V_DSHISTPADR, @C_AJUSTE_VRAJUSTEREC, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

            EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE,@V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT, @C_NF_CDCENTCUST,
                                @C_AJUSTE_VRAJUSTEREC;
        END
        ELSE IF (@C_AJUSTE_IDAJUCTREC = 'A') BEGIN
                 EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @V_STCONTCTBL, @C_AJUSTE_CDHISTPADR,
                                   @V_DSHISTPADR, @C_AJUSTE_VRAJUSTEREC, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

                 EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_NF_CDFILIEMIT, @C_NF_CDCENTCUST,
                                     @C_AJUSTE_VRAJUSTEREC;

                 SET @C_AJUSTE_VRAJUSTERECAJUST = - @C_AJUSTE_VRAJUSTEREC;
                 EXEC NOVA_PARTIDA @C_NF_CDEMPRESA, @V_CDLOTE, @V_DTCONTABIL, @V_NRLANCLOTE, @C_AJUSTE_CDCONTCTBL, @C_AJUSTE_CDHISTPADR,
                                   @V_DSHISTPADR, @C_AJUSTE_VRAJUSTERECAJUST, @V_IDLANCCOME, @V_CDCONTCOME, '01', 'S';

                 EXEC RATEIO_PARTIDA @C_NF_CDEMPRESA,@V_CDLOTE,@V_DTCONTABIL,@V_NRLANCLOTE, @C_NF_CDFILIEMIT, @C_NF_CDCENTCUST,
                                     @C_AJUSTE_VRAJUSTERECAJUST;
             END;
        END;
        FETCH NEXT FROM C_AJUSTE INTO @C_AJUSTE_DSAJUSTEREC, @C_AJUSTE_VRAJUSTEREC, @C_AJUSTE_IDAJUCTREC,
                                      @C_AJUSTE_CDHISTPADR, @C_AJUSTE_CDCONTCTBL;
     END;
     INSERT INTO RELACNFLANCLOTE 
        (CDEMPRESA, CDLOTE, NRLANCLOTE, NRSEQLANLOTE,CDFILIAL, NRLANCTONF)
       VALUES 
        (@C_NF_CDEMPRESA, @V_CDLOTE, @V_NRLANCLOTE, '00001', @C_NF_CDFILIAL, @C_NF_NRLANCTONF); 
        
     IF TEKNISA.CONFERE_PARTIDA(@C_NF_CDEMPRESA, @V_CDLOTE, @V_NRLANCLOTE,@C_NF_DTENTRSAID) = 'TRUE' BEGIN
         UPDATE NOTAFISCAL 
            SET IDSTATUSCTBNF = 'C'
          WHERE CDFILIAL   = @C_NF_CDFILIAL
            AND NRLANCTONF = @C_NF_NRLANCTONF;
     END
     ELSE BEGIN
         UPDATE NOTAFISCAL 
            SET IDSTATUSCTBNF = 'E'
          WHERE CDFILIAL   = @C_NF_CDFILIAL
            AND NRLANCTONF = @C_NF_NRLANCTONF;    
     END;  

     FETCH NEXT FROM C_NF INTO @C_NF_CDFILIAL,     @C_NF_NRLANCTONF,   @C_NF_CDEMPRESA,   @C_NF_IDDOCFINANC,
                               @C_NF_NRNOTAFISC,   @C_NF_CDCLIENTE,    @C_NF_CDFORNECED,  @C_NF_NRLANCTBDOC,
                               @C_NF_VRNOTAFISC,   @C_NF_CDFILIEMIT,   @C_NF_CDTIPOOPER,  @C_NF_IDCONTABOPER,
                               @C_NF_IDOPERDEVONF, @C_NF_IDORIGDESTNF, @C_NF_VRPRODUTOS,  @C_NF_CDFILIRECE,
                               @C_NF_DTENTRSAID,   @C_NF_CDINSCESTA,   @C_NF_DTEMISSAO,   @C_NF_IDPRIPUBCLIE,
                               @C_NF_IDENTRSAIDOP, @C_NF_CDCENTCUST,   @C_NF_CDSERIEENTR, @C_NF_CDSERIE,
                               @C_NF_IDTPIJURNF,   @C_NF_NRINSJURNF,   @C_NF_IDDTCONTAB;
  END;

  DELETE FROM LISTA
    WHERE NRLISTA = @P_NRLISTA;
END
GO